job('docpub') {
  description('''Job to publish documentation to <a href="https://doc.wikimedia.org">https://doc.wikimedia.org</a>
    <p><a href="https://gitlab.wikimedia.org/repos/releng/jenkins-deploy/-/blob/master/conf/releasing/casc/jobs/docpub.groovy">
    Job definition</a>.</p>
  '''.stripIndent())

  properties {
    authorizationMatrix {
        inheritanceStrategy {
            nonInheriting()
        }
        entries {
          user {
            name('anonymous')
            permissions([
              'Job/Read'
            ])
          }
          user {
            name("$API_USER")
            permissions([
              'Job/Read',
              'Job/Build'
            ])
          }
        }
    }
  }

  parameters {
    stringParam {
      name('CI_SERVER_HOST')
      description('The GitLab host that triggered this build')
      trim(true)
    }
    stringParam {
      name('CI_PROJECT_PATH')
      description('The project we are publishing documentation for')
      trim(true)
    }
    stringParam {
      name('GITLAB_USER_EMAIL')
      description('The email of the user that triggered the upstream pipeline')
      trim(true)
    }
    stringParam {
      name('PUB_LOCATION')
      description('The desired publishing location')
      trim(true)
    }
    stringParam {
      name('COVERAGE')
      description('Whether the docs are a test coverage report. Accepts: "true", "yes", "y"')
      trim(true)
    }
    stringParam {
      name('DOC_PRJ_DOCS_DIR')
      description('The location of the docs in the artifacts ZIP file')
      trim(true)
    }
  }
  // Adding a password param doesn't seem to be supported by either the built-in DSL or the dynamically generated DSL
  // (see README in this dir about the API viewer for more details). Another option to add a password param is to use
  // the Mask Passwords plugin, but I didn't want to install an extra plugin just for this. So I decided to use a
  // configure block (https://github.com/jenkinsci/job-dsl-plugin/wiki/The-Configure-Block) to manipulate the job's XML
  // directly
  configure { proj ->
    def parameterDefs = proj / 'properties' / 'hudson.model.ParametersDefinitionProperty' / 'parameterDefinitions'
    parameterDefs << 'hudson.model.PasswordParameterDefinition' {
        name 'DOC_PRJ_JWT'
        description 'Gitlab-generated JWT with relevant info about the publisher'
        // Always gets generated by Jenkins, even when left blank, so I added it here. Actual default value doesn't matter
        defaultValue '{AQAAABAAAAAQkvB6zvLPMp3ItF+L1cFEPNA8gsLp8Jh8FIqd4e2/Vqg=}'
    }
  }

  concurrentBuild()

  wrappers {
    credentialsBinding {
      usernamePassword('RSYNC_USER', 'RSYNC_PASSWORD', 'doc_rsync_creds')
    }
  }

  steps {
    shell('''\
      #!/bin/bash
      set -eu -o pipefail

      DC=$(dnsdomainname | cut -d. -f1)
      if [ -n "$DC" ]; then
        export HTTPS_PROXY="http://webproxy.$DC.wmnet:8080"
      fi

      docker run --rm --pull=always \
-e HTTPS_PROXY -e RSYNC_USER -e RSYNC_PASSWORD -e CI_SERVER_HOST -e PUB_LOCATION \
-e COVERAGE -e DOC_PRJ_JWT -e DOC_PRJ_DOCS_DIR \
docker-registry.wikimedia.org/repos/releng/docpub docpub.py
      '''.stripIndent()
    )
  }

  publishers {
    extendedEmail {
      recipientList('$DEFAULT_RECIPIENTS')
      triggers {
        firstFailure {
          subject('Doc publish failed')
          recipientList('$DEFAULT_RECIPIENTS', '$GITLAB_USER_EMAIL')
          content('''\
            Failed to publish documentation for project "$CI_PROJECT_PATH".

            Check console output at $BUILD_URL to view the results.

          '''.stripIndent())
          sendTo {
            recipientList()
          }
        }
        fixed {
          subject('Doc publish recovered!')
          content('''\
            Check console output at $BUILD_URL to view the results.

          '''.stripIndent())
          sendTo {
            recipientList()
          }
        }
      }
    }
  }
}
